﻿Public Class Form1
    ' The priority queue.
    Private Queue As New PriorityQueue(Of String)()

    ' Add an item to the queue.
    Private Sub btnEnqueue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnqueue.Click
        Queue.Enqueue(txtValue.Text, Integer.Parse(txtPriority.Text))
        txtValue.Clear()
        txtPriority.Clear()
        txtValue.Focus()
        btnDequeue.Enabled = True
    End Sub

    ' Remove the highest priority item from the queue.
    Private Sub btnDequeue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDequeue.Click
        Dim top_value As String = ""
        Dim top_priority As Integer
        Queue.Dequeue(top_value, top_priority)
        txtValue.Text = top_value
        txtPriority.Text = top_priority.ToString()
        btnDequeue.Enabled = (Queue.NumItems > 0)
    End Sub
End Class
